//-----------------------------------------
// LScript Generic Reset Goals
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=0.1;
@version 2.2
@warnings
@script generic

// global values go here
gsetup;
gusecurr;
gtime;

generic
{
	myselect=Scene().getSelect();
	if(!myselect)
	{
		error("Please select an IK controlled object or parent");
		return;
	}

	gsetup=recall("MGResetGoalsSetup",0);
	gusecurr=recall("MGResetGoalsUseCurr",0);
	myitemchoice=recall("MGResetGoalsItemChoice",2);

    reqbegin("Reset Goals Ver:"+myversion);

    c0 = ctlinteger("Setup Frame",gsetup);
    c1 = ctlcheckbox("Use Current Frame",gusecurr);
    c2 = ctlchoice("Items",myitemchoice,@"Selected","Selected and Children"@);

    return if !reqpost();

    // get requester control values here
	gsetup=getvalue(c0);
	gusecurr=getvalue(c1);
	myitemchoice=getvalue(c2);
    reqend();
    
    store("MGResetGoalsSetup",gsetup);
    store("MGResetGoalsUseCurr",gusecurr);
    store("MGResetGoalsItemChoice",myitemchoice);

    ResetGoalsMain(myselect,myitemchoice);
    SelectItemList(myselect);
}

ResetGoalsMain:pselect,pitemchoice
{
//debug();
	gtime=Scene().currenttime;
	if(!gusecurr)
		gtime=gsetup/Scene().fps;

	for(i=1;i<=pselect.size();i++)
	{
    	myitem=pselect[i];
    	if(pitemchoice==2)
    	{
			visitnodes(myitem,"ResetGoals");
		}
		else
			ResetGoals(nil,myitem);
	}
}

ResetGoals:parent,child
{
	if(child.goal)
	{
		myfps=Scene().fps;
		mycurrtime=Scene().currenttime;
		mygoal=child.goal;
		GoToFrame(gtime*myfps);   // needed  til NT fix getWorldPosition
		mypos=child.getWorldPosition(gtime);
		myrot=child.getWorldRotation(gtime);
		GoToFrame(mycurrtime*myfps);   // needed  til NT fix getWorldPosition

//		warn(mypos.asStr());
		SelectItem(mygoal.id);
		Position(mypos);
		Rotation(myrot);
		RefreshNow();
	}
}

SelectItemList:plist
{
    if(!plist)
        return;
    SelectItem(plist[1].id);
    for(i=2;i<=plist.size();i++)
    {
        AddToSelection(plist[i].id);
    }
}

